<?php

/**
 * actualiza_titulo actions.
 *
 * @package    cobro_coactivo
 * @subpackage actualiza_titulo
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class actualiza_tituloActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_ACTUALIZA_TITULO',
        'RE_MINERAL',
        'CBR_TITULO_MINERO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RE_MINERAL,LEFT' =>
        array(
            'id_mineral' => 'CBR_ACTUALIZA_TITULO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_ACTUALIZA_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'id_actualiza_titulo' => 'id_actualiza_titulo',
            'cod_titulo' => 'cod_titulo',
            'nombre_razon' => 'nombre_razon',
            'nitocc' => 'nitocc',
            'email' => 'email',
            'id_mineral' => 'id_mineral'
        ),
        'RE_MINERAL' =>
        array(
            'cod_mineral' => 'cod_mineral',
            'descripcion' => 'mineral'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'cod_titulo', 'nitocc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_ACTUALIZA_TITULO' =>
        array(
            'id_actualiza_titulo,a' => array('!=' => array(-1)),
            'id_actualiza_titulo,b' => array('=' => array('id_actualiza_titulo')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'nitocc' => array('LIKEALLPLUS' => array('num_doc', '%')),
            'nombre_razon' => array('LIKEALLPLUS' => array('nombre_razon', '%')),
            'id_mineral' => array('=' => array('id_mineral')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_actualiza_titulo'; //identificador de la tabla
    protected $id_names = array('id_actualiza_titulo'); //llave primaria
    protected $field_names = array('cod_titulo', 'nombre_razon', 'nitocc', 'email','id_mineral'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_ACTUALIZA_TITULO'; //tabla en la cual se aplican los cambios 
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_actualiza_titulo'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            /**
             * Se crea datos titular si existen para el tercero - 20160216
             */
            try {
                $id_actualiza_titulo = $list_data_post[0]['id_actualiza_titulo'];
                $nitocc = $list_data_post[0]['nitocc'];

                $sql = <<<EOD
select * from cbr_datos_titular
where
id_actualiza_titulo = $id_actualiza_titulo 
EOD;

                $results = CN_TABLE::executeSQL($sql);
                //valida que exite registro
                if (count($results) == 0) {
                    $sql = <<<EOD
select * from interceros_du_dir_v
where
num_doc = '$nitocc' 
EOD;

                    $results = CN_TABLE::executeSQL($sql);
                    //valida que existe tercero
                    if (count($results) > 0) {

                        $telefono = $results[0]['tel'];
                        $direccion = $results[0]['direccion'];
                        $id_depto = $results[0]['coddepto'];

                        $sql = <<<EOD
Insert into CBR_DATOS_TITULAR (ID_DATOS_TITULAR,ID_ACTUALIZA_TITULO,TELEFONO,DIRECCION,ID_DEPTO,CODMUN) 
    values (null,$id_actualiza_titulo,'$telefono','$direccion',
    ( select max(id_depto) from DEPARTAMENTO where coddepto = nvl('$id_depto','11')),nvl( (SELECT min(codmun) FROM municipios where depto = ( select max(id_depto) from DEPARTAMENTO where coddepto = nvl('$id_depto','11')) ),'11001') )
EOD;
                        $this->conn->execute($sql);
                    }
                }

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            //Reemplazar espacios en blanco - 20160216
            $request['cod_titulo'] = str_replace(' ', '', $request['cod_titulo']);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $cod_titulo = $request['cod_titulo'];
        $nitocc = $request['nitocc'];

        /*
         *  Validar la operación, ya sea por SQL
         */
        $sql = <<<EOD
select * from cbr_actualiza_titulo
where
cod_titulo = '$cod_titulo' 
and nitocc = $nitocc
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya existen registros para el Título " . $cod_titulo . " y NitoCc " . $nitocc;
            $errors['servicio'] = "actualiza_titulo";
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
